```
wc [options] [files]	# 统计给定文件中的字节数，字数或行数。
```

#### 选项

```
-c 		# 统计字节数
-w 		# 统计字数
-l 		# 统计行数
```

#### 例子

```
wc -l *			# 统计当前目录下所有文件的行数
find . * | xargs wc -l 	# 递归统计当前目录下所有文件的行数
find . * | xargs cat | grep -v ^$ | wc -l	# 递归统计当前目录下所有文件的行数，过滤了空行
```

#### 问题

1. `wc -l`命令统计到的文件行数，比文件实际行数少一行。

   原因分析：wc是通过`\n`的数量来统计行数的，某些文件是以`EOF`结尾的，所以少统计了一行。可以通过`xxd`命令查看二进制，其中`0a`为LF(即`\n`)，在文件结尾应该是没有`0a`的。

​	