1. **zcu102**平台简介

   是项目演示平台，运行的是microblaze(不是riscv)，可以进行cache划分和监控，内存带宽的划分和监控(注：内存带宽的监控目前还有bug，暂时不能使用20180117)

   其内部结构是有一个fpga服务器，fpga服务器通过串口控制着开发板arm核上的主控OS（PRM），PRM进而控制着开发板上的fpga部分：4个microblaze核及其上的OS。

2. 登陆zcu102平台

   1. 清华校内可以选择**DIVI**网络使用ipv6，第一次注册后大概需要**30分钟**才能访问ipv6网络

   2. ssh登陆fpga服务器

      `ssh -X remoteServer`

   3. 使用minicom登陆开发板

      ````shell
      minicom -D /dev/ttyUSB0
      # 如果键盘输入无反应，应在“配置->Serial port setup”里将F,G两项均设置为No。
      ````

   4. 可以看到zcu102启动过程，如已启动，应使用reboot命令重启以确保是以mbboot模式启动。

   5. 重启后会看到倒计数，倒计数结束前要按任意键打断，然后输入run mbboot命令启动PRM。

   6. 通过ifconfig查看PRM的ip地址。

   7. 在fpga服务器通过ssh登陆PRM。

3. 开启UI界面

   ```bash
   #在PRM内运行如下命令
   cd yzh/md/
   bash kspard		#创建LDom，并设置dsid,开启UI服务
   pardctl stab -w	#每秒读出PaRD统计表中的内容
   ```
   ```shell
   #在fpga服务器上运行如下命令
   firefox (PRM addr):8000	#例如 firefox 1.2.3.4:8000
   ```

   ​

4. 向一个LDom发送请求查看缓存，内存和尾延迟的情况

   ```shell
   # 一个窗格建立连接
   minicom -D /dev/ttyUL1
   ```

   ```shell
   # 另一个窗格启动aaa
   pardctl start-ldom aaa
   ```

   ```shell
   # aaa登陆
   memcached -d -u root	#启动memcached server
   ifconfig		#获取aaa的地址
   ```

   向aaa发送请求，可以看到尾延迟的情况

   ```shell
   #在fpga服务器中输入如下命令
   cd scripts
   #编辑core0.txt，将ip地址改为aaa的地址
   sudo bash run_client.sh core0.txt
   #编辑ui.sh，将root@xx.xx.xxx.xxx处的IP地址改为PRM的IP
   bash ui.sh	#此时可以在UI中观察尾延迟的情况
   ```

5. 打开其它3个Ldom进行文件操作以查看缓存、内存和尾延迟的情况

   ```shell
   minicom -D /dev/ttyUL[2|3|4]	#开启到其它三个核的连接bbb、ccc、ddd
   bash yzh/mb/startall.sh	#开启其它的三个核，注意观察UI变化
   ```

   ```shell
   cat copyfile.sh		#获取要复制的命令
   #在其它核中(aaa|bbb|ccc)运行上步复制到的命令，注意观察UI变化
   bash yzh/mb/waymask_ctl_75.sh	#给缓存划分单独的12路LLC,观察UI变化
   bash yzh/mb/waymask_ctl_93.sh	#给缓存划分单独的15路LLC,观察UI变化
   ```
   ​

6. 退出系统

   ```shell
   #退出PRM即可,在PRM窗口输入以下命令
   poweroff​
   ```
